#!/bin/bash

#	Megaupload script make your downloads easier from http://www.megaupload.com
#	Copyright (C) 2008  Aurélien Dominguez tenkaistar@gmail.com
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [ -f "$HOME/.megaup.conf" ]
then	. $HOME/.megaup.conf
else	echo "Configuration file is missing, please copy the .megaup.conf file provided in the script package to $HOME/.megaup.conf and edit it accordingly to your setup."
	exit 3
fi

image=$1
imagenoext=${image%.*}

chrcolor1="#786464"
chrcolor2="#AA6464"
chrcolor3="#DC6464"
background="#FFFFFF"


# Convert image to pnm format
$im_convert "$image" "$imagenoext.pnm"
image="$imagenoext.pnm"



# Getting image unwanted color list :
$im_convert  $image histogram:- | $im_identify -depth 4 -format %c - | head -c -1 > $imagenoext.hist 


exec 10<$imagenoext.hist

declare -i colorcount=0
declare -i colorpos=0
declare -i i=0
declare -a uselesscolors

while read line<&10 
do	
	color=`echo $line | cut -d\  -f3`
	if [ "$color" != "$chrcolor1" ] && [ "$color" != "$chrcolor2" ] && [ "$color" != "$chrcolor3" ] && [ "$color" != "$background" ] 
	then
		uselesscolors[$i]="$color"
		i=`expr $i + 1`
	fi	
done

exec 10>&-

# Clean image from any useless color

workimage=$imagenoext"_work.pnm"

cnt=`expr $i - 1`
for ((i=$cnt;i>=0;i-=1));do
	$im_convert -fill "$background" "$image" -opaque "${uselesscolors[$i]}" "$workimage"
	cp "$workimage" "$image"
done

# Creating 1 image for each characters 
cp "$image" "$workimage"

ext="1.pnm"
$im_convert -fill "$background" "$workimage" -opaque "$chrcolor2" "$imagenoext$ext"
cp "$imagenoext$ext" "$workimage"
$im_convert -fill "$background" "$workimage" -opaque "$chrcolor3" "$imagenoext$ext"

cp "$image" "$workimage"

ext="2.pnm"
$im_convert -fill "$background" "$workimage" -opaque "$chrcolor1" "$imagenoext$ext"
cp "$imagenoext$ext" "$workimage"
$im_convert -fill "$background" "$workimage" -opaque "$chrcolor3" "$imagenoext$ext"

cp "$image" "$workimage"

ext="3.pnm"
$im_convert -fill "$background" "$workimage" -opaque "$chrcolor1" "$imagenoext$ext"
cp "$imagenoext$ext" "$workimage"
$im_convert -fill "$background" "$workimage" -opaque "$chrcolor2" "$imagenoext$ext"


# Reading images with ocr then echo a string built with the 3 characters

chr1=`$ocr $imagenoext"1.pnm"`
chr2=`$ocr $imagenoext"2.pnm"`
chr3=`$ocr $imagenoext"3.pnm"`

echo $chr1$chr2$chr3
