#!/bin/bash

#	Megaupload script make your downloads easier from http://www.megaupload.com
#	Copyright (C) 2008  Aurélien Dominguez tenkaistar@gmail.com
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [ -f "$HOME/.megaup.conf" ]
then	. $HOME/.megaup.conf
else	echo "Configuration file is missing, please copy the .megaup.conf file provided in the script package to $HOME/.megaup.conf and edit it accordingly to your setup."
	exit 3
fi

if [ -f $globallogfile ]
then	echo "" > /dev/null
else	touch $globallogfile
fi

cat $1 | while read line
do
	echo $line | grep --silent ^#
	returncode=$?
	if [ $returncode == 0 ]
	then	check=1
	else	check=0
	fi
	
	while [ "$check" == "0" ]
	do	
		$megaupdl "$line" >> $globallogfile
		returncode=$?
		if [ "$returncode" == "0" ]
		then 	check="1"
		elif [ "$returncode" == "1" ]
		then	check="1"
			echo "$line link doesn't exist."
		elif [ "$returncode" == "2" ]
		then	check="0"
			echo "Download Limit reached, next try in $wait seconds..." >> $globallogfile
			sleep $wait
		else	check="1"
 		fi
	done
done
